#include <bits/stdc++.h>
using namespace std;

int bolji_log(unsigned int n){
	int log = 0;
	while (n){
		n = n>>1;
		log++;
	}
	return log;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie();
	int N, Q; cin >> N >> Q;
	int A[N];
	for (int i = 0; i < N; i++){
		cin >> A[i];
		A[i] = bolji_log(A[i]);
	}
	int maksimalni;
	while(Q--){
		int L, R; cin >> L >> R;
		unordered_map<int, int> mapa;
		for (int i = L-1; i < R; i++){
			mapa[A[i]]++;
			maksimalni = mapa[A[i]];
		}
		for (pair<int, int> it : mapa){
			maksimalni = max(maksimalni, it.second);
		}
		cout << maksimalni << '\n';
		
	}
	


return 0;
}